pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/notification/CosNotifyChannelAdmin.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with PolyORB.Any.NVList;
with PolyORB.Types;
with CORBA.Object.Helper;
with CORBA.Object;
with PolyORB.Any;
with CosNotifyComm.StructuredPushConsumer.Helper;
with PolyORB.Requests;
with CORBA.ExceptionList;
with CosEventChannelAdmin.Helper;
with PolyORB.CORBA_P.Interceptors_Hooks;
with PolyORB.CORBA_P.Exceptions;
with CosNotifyChannelAdmin.Helper;
with CosNotification.Helper;
with CosNotifyComm.Helper;
with CosNotification.QoSAdmin;
with CosNotifyFilter.FilterAdmin;
with CosNotifyComm.StructuredPushSupplier;
with CosNotifyComm.NotifySubscribe;

package body CosNotifyChannelAdmin.StructuredProxyPushSupplier is

   connect_structured_push_consumer_Arg_Name_push_consumer_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("push_consumer");

   connect_structured_push_consumer_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -----------------------------------------------
   -- connect_structured_push_consumer_Result_ --
   -----------------------------------------------

   function connect_structured_push_consumer_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (connect_structured_push_consumer_Result_);
   begin
      return (Name => connect_structured_push_consumer_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end connect_structured_push_consumer_Result_;

   --------------------------------------
   -- connect_structured_push_consumer --
   --------------------------------------

   procedure connect_structured_push_consumer
     (Self : Ref;
      push_consumer : CosNotifyComm.StructuredPushConsumer.Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_push_consumer_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (push_consumer)'Unrestricted_Access);
      Arg_Any_push_consumer_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyComm.StructuredPushConsumer.Helper.TC_StructuredPushConsumer,
            Arg_CC_push_consumer_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        connect_structured_push_consumer_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         connect_structured_push_consumer_Arg_Name_push_consumer_,
         PolyORB.Any.Any
           (Arg_Any_push_consumer_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosEventChannelAdmin.Helper.TC_AlreadyConnected);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosEventChannelAdmin.Helper.TC_TypeError);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "connect_structured_push_consumer",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end connect_structured_push_consumer;

   suspend_connection_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ---------------------------------
   -- suspend_connection_Result_ --
   ---------------------------------

   function suspend_connection_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (suspend_connection_Result_);
   begin
      return (Name => suspend_connection_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end suspend_connection_Result_;

   ------------------------
   -- suspend_connection --
   ------------------------

   procedure suspend_connection
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        suspend_connection_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyChannelAdmin.Helper.TC_ConnectionAlreadyInactive);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyChannelAdmin.Helper.TC_NotConnected);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "suspend_connection",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end suspend_connection;

   resume_connection_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   --------------------------------
   -- resume_connection_Result_ --
   --------------------------------

   function resume_connection_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (resume_connection_Result_);
   begin
      return (Name => resume_connection_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end resume_connection_Result_;

   -----------------------
   -- resume_connection --
   -----------------------

   procedure resume_connection
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        resume_connection_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyChannelAdmin.Helper.TC_ConnectionAlreadyActive);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyChannelAdmin.Helper.TC_NotConnected);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "resume_connection",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end resume_connection;

   disconnect_structured_push_supplier_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   --------------------------------------------------
   -- disconnect_structured_push_supplier_Result_ --
   --------------------------------------------------

   function disconnect_structured_push_supplier_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (disconnect_structured_push_supplier_Result_);
   begin
      return (Name => disconnect_structured_push_supplier_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end disconnect_structured_push_supplier_Result_;

   -----------------------------------------
   -- disconnect_structured_push_supplier --
   -----------------------------------------

   procedure disconnect_structured_push_supplier
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        disconnect_structured_push_supplier_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "disconnect_structured_push_supplier",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end disconnect_structured_push_supplier;

   subscription_change_Arg_Name_added_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("added");

   subscription_change_Arg_Name_removed_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("removed");

   subscription_change_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ----------------------------------
   -- subscription_change_Result_ --
   ----------------------------------

   function subscription_change_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (subscription_change_Result_);
   begin
      return (Name => subscription_change_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end subscription_change_Result_;

   -------------------------
   -- subscription_change --
   -------------------------

   procedure subscription_change
     (Self : Ref;
      added : CosNotification.EventTypeSeq;
      removed : CosNotification.EventTypeSeq)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_added_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_EventType.Sequence
              (added)'Unrestricted_Access);
      Arg_Any_added_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_EventTypeSeq,
            Arg_CC_added_'Unchecked_Access);
      Arg_CC_removed_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_EventType.Sequence
              (removed)'Unrestricted_Access);
      Arg_Any_removed_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_EventTypeSeq,
            Arg_CC_removed_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        subscription_change_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         subscription_change_Arg_Name_added_,
         PolyORB.Any.Any
           (Arg_Any_added_),
         PolyORB.Any.ARG_IN);
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         subscription_change_Arg_Name_removed_,
         PolyORB.Any.Any
           (Arg_Any_removed_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyComm.Helper.TC_InvalidEventType);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "subscription_change",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end subscription_change;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (False
         or else (Is_A
           (Logical_Type_Id)
            or else CORBA.Object.Is_A
              (CORBA.Object.Ref
                 (Self),
               Logical_Type_Id)));
   end Is_A;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (((CORBA.Is_Equivalent
        (Logical_Type_Id,
         CosNotifyChannelAdmin.StructuredProxyPushSupplier.Repository_Id)
         or else CORBA.Is_Equivalent
           (Logical_Type_Id,
            "IDL:omg.org/CORBA/Object:1.0"))
         or else (((CORBA.Is_Equivalent
           (Logical_Type_Id,
            CosNotifyChannelAdmin.ProxySupplier.Repository_Id)
            or else (CORBA.Is_Equivalent
              (Logical_Type_Id,
               CosNotification.QoSAdmin.Repository_Id)
               or else CORBA.Is_Equivalent
                 (Logical_Type_Id,
                  CosNotifyFilter.FilterAdmin.Repository_Id)))
            or else CORBA.Is_Equivalent
              (Logical_Type_Id,
               CosNotifyComm.StructuredPushSupplier.Repository_Id))
            or else CORBA.Is_Equivalent
              (Logical_Type_Id,
               CosNotifyComm.NotifySubscribe.Repository_Id)))
         or else False);
   end Is_A;

end CosNotifyChannelAdmin.StructuredProxyPushSupplier;
