pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/notification/CosNotifyComm.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CosNotifyComm.StructuredPullConsumer.Impl;
with CORBA.ServerRequest;
with CORBA.NVList;
with CosNotification;
with CORBA;
pragma Elaborate_All (CORBA);
with CosNotification.Helper;
with PolyORB.Any;
with CosNotifyComm.Helper;
with PolyORB.CORBA_P.IR_Hooks;
with CORBA.Object;
with CORBA.Object.Helper;
with PolyORB.CORBA_P.Domain_Management;
with CosNotifyComm_StructuredPullConsumer_Hash;
with PolyORB.Std;
with PortableServer;
with CORBA.ORB;
with PolyORB.CORBA_P.Exceptions;
with PolyORB.Qos.Exception_Informations;
with PolyORB.Utils.Strings;
with PolyORB.Utils.Strings.Lists;
with PolyORB.Initialization;

package body CosNotifyComm.StructuredPullConsumer.Skel is

   offer_change_Arg_Name_added_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("added");

   offer_change_Arg_Name_removed_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("removed");

   N_Operations : constant PolyORB.Std.Natural :=
     7;

   type String_Ptr is
     access PolyORB.Std.String;

   Invoke_Db : array (0 .. (N_Operations
      - 1)) of String_Ptr :=
     (others => null);

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String);

   ------------------------
   -- Register_Procedure --
   ------------------------

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String)
   is
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;
   begin
      Index_ :=
        CosNotifyComm_StructuredPullConsumer_Hash.Hash
           (Operation_Name);
      if (Invoke_Db
        (Index_)
         /= null)
      then
         raise Program_Error;
      end if;
      Invoke_Name_Access :=
        new PolyORB.Std.String'
           (Operation_Name);
      Invoke_Db
        (Index_) :=
        Invoke_Name_Access;
   end Register_Procedure;

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr);

   ------------
   -- Invoke --
   ------------

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr)
   is
      Operation_ : constant PolyORB.Std.String :=
        CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation
              (Request.all));
      Argument_List_ : CORBA.NVList.Ref;
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;

      procedure Invoke_disconnect_structured_pull_consumer;

      ------------------------------------------------
      -- Invoke_disconnect_structured_pull_consumer --
      ------------------------------------------------

      procedure Invoke_disconnect_structured_pull_consumer is
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         CosNotifyComm.StructuredPullConsumer.Impl.disconnect_structured_pull_consumer
           (CosNotifyComm.StructuredPullConsumer.Impl.Object'Class
              (Self.all)'Access);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_disconnect_structured_pull_consumer;

      procedure Invoke_offer_change;

      -------------------------
      -- Invoke_offer_change --
      -------------------------

      procedure Invoke_offer_change is
         Argument_added_ : CosNotification.EventTypeSeq;
         pragma Warnings (Off, Argument_added_);
         pragma Suppress (Validity_Check, Argument_added_);
         Arg_CC_added_ : aliased PolyORB.Any.Content'Class :=
           CosNotification.Helper.Internals.Wrap
              (CosNotification.IDL_SEQUENCE_CosNotification_EventType.Sequence
                 (Argument_added_)'Unrestricted_Access);
         Arg_Any_added_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosNotification.Helper.TC_EventTypeSeq,
               Arg_CC_added_'Unchecked_Access);
         Argument_removed_ : CosNotification.EventTypeSeq;
         pragma Warnings (Off, Argument_removed_);
         pragma Suppress (Validity_Check, Argument_removed_);
         Arg_CC_removed_ : aliased PolyORB.Any.Content'Class :=
           CosNotification.Helper.Internals.Wrap
              (CosNotification.IDL_SEQUENCE_CosNotification_EventType.Sequence
                 (Argument_removed_)'Unrestricted_Access);
         Arg_Any_removed_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosNotification.Helper.TC_EventTypeSeq,
               Arg_CC_removed_'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            offer_change_Arg_Name_added_,
            Arg_Any_added_,
            CORBA.ARG_IN);
         CORBA.NVList.Add_Item
           (Argument_List_,
            offer_change_Arg_Name_removed_,
            Arg_Any_removed_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         begin
            --  Call Implementation
            CosNotifyComm.StructuredPullConsumer.Impl.offer_change
              (CosNotifyComm.StructuredPullConsumer.Impl.Object'Class
                 (Self.all)'Access,
               Argument_added_,
               Argument_removed_);
         exception
            when E : CosNotifyComm.InvalidEventType =>
               declare
                  Members : CosNotifyComm.InvalidEventType_Members;
               begin
                  CosNotifyComm.Get_Members
                    (E,
                     Members);
                  CORBA.ServerRequest.Set_Exception
                    (Request,
                     CosNotifyComm.Helper.To_Any
                       (Members));
                  return;
               end;
         end;
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_offer_change;

      procedure Invoke_Uis_a;

      ------------------
      -- Invoke_Uis_a --
      ------------------

      procedure Invoke_Uis_a is
         Type_Id_ : CORBA.String;
         Arg_Name_Type_Id_ : constant CORBA.Identifier :=
           CORBA.To_CORBA_String
              ("Type_Id_");
         Argument_Type_Id_ : constant CORBA.Any :=
           CORBA.To_Any
              (Type_Id_);
         Result_ : CORBA.Boolean;
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            Arg_Name_Type_Id_,
            Argument_Type_Id_,
            CORBA.ARG_IN);
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         Type_Id_ :=
           CORBA.From_Any
              (Argument_Type_Id_);
         Result_ :=
           Is_A
              (CORBA.To_Standard_String
                 (Type_Id_));
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (Result_));
      end Invoke_Uis_a;

      procedure Invoke_Uinterface;

      -----------------------
      -- Invoke_Uinterface --
      -----------------------

      procedure Invoke_Uinterface is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
              (CORBA.Object.Ref
                 (PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
                    (CORBA.To_CORBA_String
                       (Repository_Id)))));
      end Invoke_Uinterface;

      procedure Invoke_Udomain_managers;

      -----------------------------
      -- Invoke_Udomain_managers --
      -----------------------------

      procedure Invoke_Udomain_managers is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers
              (Self));
      end Invoke_Udomain_managers;

      procedure Invoke_Unon_existent;

      --------------------------
      -- Invoke_Unon_existent --
      --------------------------

      procedure Invoke_Unon_existent is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (CORBA.Boolean'
                 (False)));
      end Invoke_Unon_existent;

      procedure Dispatch;

      --------------
      -- Dispatch --
      --------------

      procedure Dispatch is
      begin
         case Index_ is
            when 0 =>
               Invoke_disconnect_structured_pull_consumer;
            when 1 =>
               Invoke_offer_change;
            when 3 =>
               Invoke_Uinterface;
            when 4 =>
               Invoke_Udomain_managers;
            when 5
               | 6 =>
               Invoke_Unon_existent;
            when 2 =>
               Invoke_Uis_a;
            pragma Warnings (Off);
            when others =>
               raise Program_Error;
            pragma Warnings (On);

         end case;
      end Dispatch;

   begin
      CORBA.ORB.Create_List
        (0,
         Argument_List_);
      Index_ :=
        CosNotifyComm_StructuredPullConsumer_Hash.Hash
           (Operation_);
      Invoke_Name_Access :=
        Invoke_Db
           (Index_);
      begin
         if (Operation_
            = Invoke_Name_Access.all)
         then
            Dispatch;
         else
            CORBA.Raise_Bad_Operation
              (CORBA.Default_Sys_Member);
         end if;
      exception
         when E : others =>
            CORBA.ServerRequest.Set_Exception
              (Request,
               PolyORB.CORBA_P.Exceptions.System_Exception_To_Any
                 (E));
            PolyORB.Qos.Exception_Informations.Set_Exception_Information
              (Request.all,
               E);
      end;
   end Invoke;

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean;

   ------------------
   -- Servant_Is_A --
   ------------------

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean
   is
   begin
      return (Obj.all
         in CosNotifyComm.StructuredPullConsumer.Impl.Object'Class);
   end Servant_Is_A;

   -----------------------------
   -- Deferred_Initialization --
   -----------------------------

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CosNotifyComm.StructuredPullConsumer.Repository_Id,
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);
      Register_Procedure
        ("disconnect_structured_pull_consumer");
      Register_Procedure
        ("offer_change");
      Register_Procedure
        ("_is_a");
      Register_Procedure
        ("_interface");
      Register_Procedure
        ("_domain_managers");
      Register_Procedure
        ("_non_existent");
      Register_Procedure
        ("_not_existent");
   end Deferred_Initialization;

begin
   declare
      use PolyORB.Utils.Strings;
      use PolyORB.Utils.Strings.Lists;
   begin
      PolyORB.Initialization.Register_Module
        (PolyORB.Initialization.Module_Info'
           (Name => +"CosNotifyComm.StructuredPullConsumer.Skel",
            Conflicts => PolyORB.Utils.Strings.Lists.Empty,
            Depends => PolyORB.Utils.Strings.Lists.Empty
               & "CosNotifyComm.NotifyPublish.Skel?",
            Provides => PolyORB.Utils.Strings.Lists.Empty,
            Implicit => False,
            Init => Deferred_Initialization'Access,
            Shutdown => null));
   end;
end CosNotifyComm.StructuredPullConsumer.Skel;
