pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/notification/CosNotifyFilter.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with PolyORB.Any.NVList;
with PolyORB.Any;
with PolyORB.Requests;
with PolyORB.Types;
with PolyORB.CORBA_P.Interceptors_Hooks;
with PolyORB.CORBA_P.Exceptions;
with CosNotifyFilter.Helper;
with CORBA.ExceptionList;
with CosNotification.Helper;
with CORBA.Object.Helper;
with CosNotifyComm.NotifySubscribe.Helper;

package body CosNotifyFilter.Filter is

   get_constraint_grammar_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -------------------------------------
   -- get_constraint_grammar_Result_ --
   -------------------------------------

   function get_constraint_grammar_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (get_constraint_grammar_Result_);
   begin
      return (Name => get_constraint_grammar_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_String),
      Arg_Modes => 0);
   end get_constraint_grammar_Result_;

   ----------------------------
   -- get_constraint_grammar --
   ----------------------------

   function get_constraint_grammar
     (Self : Ref)
     return CORBA.String
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CORBA.String;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (Result_'Unrestricted_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        get_constraint_grammar_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "_get_constraint_grammar",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end get_constraint_grammar;

   add_constraints_Arg_Name_constraint_list_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("constraint_list");

   add_constraints_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ------------------------------
   -- add_constraints_Result_ --
   ------------------------------

   function add_constraints_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (add_constraints_Result_);
   begin
      return (Name => add_constraints_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.Helper.TC_ConstraintInfoSeq),
      Arg_Modes => 0);
   end add_constraints_Result_;

   ---------------------
   -- add_constraints --
   ---------------------

   function add_constraints
     (Self : Ref;
      constraint_list : CosNotifyFilter.ConstraintExpSeq)
     return CosNotifyFilter.ConstraintInfoSeq
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.ConstraintInfoSeq;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintInfo.Sequence
              (Result_)'Unrestricted_Access);
      Arg_CC_constraint_list_ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintExp.Sequence
              (constraint_list)'Unrestricted_Access);
      Arg_Any_constraint_list_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyFilter.Helper.TC_ConstraintExpSeq,
            Arg_CC_constraint_list_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        add_constraints_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         add_constraints_Arg_Name_constraint_list_,
         PolyORB.Any.Any
           (Arg_Any_constraint_list_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_InvalidConstraint);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "add_constraints",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end add_constraints;

   modify_constraints_Arg_Name_del_list_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("del_list");

   modify_constraints_Arg_Name_modify_list_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("modify_list");

   modify_constraints_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ---------------------------------
   -- modify_constraints_Result_ --
   ---------------------------------

   function modify_constraints_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (modify_constraints_Result_);
   begin
      return (Name => modify_constraints_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end modify_constraints_Result_;

   ------------------------
   -- modify_constraints --
   ------------------------

   procedure modify_constraints
     (Self : Ref;
      del_list : CosNotifyFilter.ConstraintIDSeq;
      modify_list : CosNotifyFilter.ConstraintInfoSeq)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_del_list_ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintID.Sequence
              (del_list)'Unrestricted_Access);
      Arg_Any_del_list_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyFilter.Helper.TC_ConstraintIDSeq,
            Arg_CC_del_list_'Unchecked_Access);
      Arg_CC_modify_list_ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintInfo.Sequence
              (modify_list)'Unrestricted_Access);
      Arg_Any_modify_list_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyFilter.Helper.TC_ConstraintInfoSeq,
            Arg_CC_modify_list_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        modify_constraints_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         modify_constraints_Arg_Name_del_list_,
         PolyORB.Any.Any
           (Arg_Any_del_list_),
         PolyORB.Any.ARG_IN);
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         modify_constraints_Arg_Name_modify_list_,
         PolyORB.Any.Any
           (Arg_Any_modify_list_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_InvalidConstraint);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_ConstraintNotFound);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "modify_constraints",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end modify_constraints;

   get_constraints_Arg_Name_id_list_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("id_list");

   get_constraints_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ------------------------------
   -- get_constraints_Result_ --
   ------------------------------

   function get_constraints_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (get_constraints_Result_);
   begin
      return (Name => get_constraints_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.Helper.TC_ConstraintInfoSeq),
      Arg_Modes => 0);
   end get_constraints_Result_;

   ---------------------
   -- get_constraints --
   ---------------------

   function get_constraints
     (Self : Ref;
      id_list : CosNotifyFilter.ConstraintIDSeq)
     return CosNotifyFilter.ConstraintInfoSeq
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.ConstraintInfoSeq;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintInfo.Sequence
              (Result_)'Unrestricted_Access);
      Arg_CC_id_list_ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintID.Sequence
              (id_list)'Unrestricted_Access);
      Arg_Any_id_list_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyFilter.Helper.TC_ConstraintIDSeq,
            Arg_CC_id_list_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        get_constraints_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         get_constraints_Arg_Name_id_list_,
         PolyORB.Any.Any
           (Arg_Any_id_list_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_ConstraintNotFound);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "get_constraints",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end get_constraints;

   get_all_constraints_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ----------------------------------
   -- get_all_constraints_Result_ --
   ----------------------------------

   function get_all_constraints_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (get_all_constraints_Result_);
   begin
      return (Name => get_all_constraints_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.Helper.TC_ConstraintInfoSeq),
      Arg_Modes => 0);
   end get_all_constraints_Result_;

   -------------------------
   -- get_all_constraints --
   -------------------------

   function get_all_constraints
     (Self : Ref)
     return CosNotifyFilter.ConstraintInfoSeq
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.ConstraintInfoSeq;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_ConstraintInfo.Sequence
              (Result_)'Unrestricted_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        get_all_constraints_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "get_all_constraints",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end get_all_constraints;

   remove_all_constraints_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -------------------------------------
   -- remove_all_constraints_Result_ --
   -------------------------------------

   function remove_all_constraints_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (remove_all_constraints_Result_);
   begin
      return (Name => remove_all_constraints_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end remove_all_constraints_Result_;

   ----------------------------
   -- remove_all_constraints --
   ----------------------------

   procedure remove_all_constraints
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        remove_all_constraints_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "remove_all_constraints",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end remove_all_constraints;

   destroy_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ----------------------
   -- destroy_Result_ --
   ----------------------

   function destroy_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (destroy_Result_);
   begin
      return (Name => destroy_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end destroy_Result_;

   -------------
   -- destroy --
   -------------

   procedure destroy
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        destroy_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "destroy",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end destroy;

   match_Arg_Name_filterable_data_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("filterable_data");

   match_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   --------------------
   -- match_Result_ --
   --------------------

   function match_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (match_Result_);
   begin
      return (Name => match_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Boolean),
      Arg_Modes => 0);
   end match_Result_;

   -----------
   -- match --
   -----------

   function match
     (Self : Ref;
      filterable_data : CORBA.Any)
     return CORBA.Boolean
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CORBA.Boolean;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (Result_'Unrestricted_Access);
      Arg_CC_filterable_data_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (filterable_data'Unrestricted_Access);
      Arg_Any_filterable_data_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CORBA.TC_Any,
            Arg_CC_filterable_data_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        match_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         match_Arg_Name_filterable_data_,
         PolyORB.Any.Any
           (Arg_Any_filterable_data_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_UnsupportedFilterableData);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "match",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end match;

   match_structured_Arg_Name_filterable_data_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("filterable_data");

   match_structured_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -------------------------------
   -- match_structured_Result_ --
   -------------------------------

   function match_structured_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (match_structured_Result_);
   begin
      return (Name => match_structured_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Boolean),
      Arg_Modes => 0);
   end match_structured_Result_;

   ----------------------
   -- match_structured --
   ----------------------

   function match_structured
     (Self : Ref;
      filterable_data : CosNotification.StructuredEvent)
     return CORBA.Boolean
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CORBA.Boolean;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (Result_'Unrestricted_Access);
      Arg_CC_filterable_data_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (filterable_data'Unrestricted_Access);
      Arg_Any_filterable_data_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_StructuredEvent,
            Arg_CC_filterable_data_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        match_structured_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         match_structured_Arg_Name_filterable_data_,
         PolyORB.Any.Any
           (Arg_Any_filterable_data_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_UnsupportedFilterableData);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "match_structured",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end match_structured;

   match_typed_Arg_Name_filterable_data_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("filterable_data");

   match_typed_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   --------------------------
   -- match_typed_Result_ --
   --------------------------

   function match_typed_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (match_typed_Result_);
   begin
      return (Name => match_typed_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Boolean),
      Arg_Modes => 0);
   end match_typed_Result_;

   -----------------
   -- match_typed --
   -----------------

   function match_typed
     (Self : Ref;
      filterable_data : CosNotification.PropertySeq)
     return CORBA.Boolean
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CORBA.Boolean;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (Result_'Unrestricted_Access);
      Arg_CC_filterable_data_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_Property.Sequence
              (filterable_data)'Unrestricted_Access);
      Arg_Any_filterable_data_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_PropertySeq,
            Arg_CC_filterable_data_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        match_typed_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         match_typed_Arg_Name_filterable_data_,
         PolyORB.Any.Any
           (Arg_Any_filterable_data_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_UnsupportedFilterableData);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "match_typed",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end match_typed;

   attach_callback_Arg_Name_callback_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("callback");

   attach_callback_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ------------------------------
   -- attach_callback_Result_ --
   ------------------------------

   function attach_callback_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (attach_callback_Result_);
   begin
      return (Name => attach_callback_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.Helper.TC_CallbackID),
      Arg_Modes => 0);
   end attach_callback_Result_;

   ---------------------
   -- attach_callback --
   ---------------------

   function attach_callback
     (Self : Ref;
      callback : CosNotifyComm.NotifySubscribe.Ref)
     return CosNotifyFilter.CallbackID
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.CallbackID;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (CORBA.Long
              (Result_)'Unrestricted_Access);
      Arg_CC_callback_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (callback)'Unrestricted_Access);
      Arg_Any_callback_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyComm.NotifySubscribe.Helper.TC_NotifySubscribe,
            Arg_CC_callback_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        attach_callback_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         attach_callback_Arg_Name_callback_,
         PolyORB.Any.Any
           (Arg_Any_callback_),
         PolyORB.Any.ARG_IN);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "attach_callback",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end attach_callback;

   detach_callback_Arg_Name_callback_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("callback");

   detach_callback_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ------------------------------
   -- detach_callback_Result_ --
   ------------------------------

   function detach_callback_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (detach_callback_Result_);
   begin
      return (Name => detach_callback_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end detach_callback_Result_;

   ---------------------
   -- detach_callback --
   ---------------------

   procedure detach_callback
     (Self : Ref;
      callback : CosNotifyFilter.CallbackID)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_callback_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (CORBA.Long
              (callback)'Unrestricted_Access);
      Arg_Any_callback_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotifyFilter.Helper.TC_CallbackID,
            Arg_CC_callback_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        detach_callback_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         detach_callback_Arg_Name_callback_,
         PolyORB.Any.Any
           (Arg_Any_callback_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_CallbackNotFound);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "detach_callback",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end detach_callback;

   get_callbacks_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ----------------------------
   -- get_callbacks_Result_ --
   ----------------------------

   function get_callbacks_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (get_callbacks_Result_);
   begin
      return (Name => get_callbacks_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.Helper.TC_CallbackIDSeq),
      Arg_Modes => 0);
   end get_callbacks_Result_;

   -------------------
   -- get_callbacks --
   -------------------

   function get_callbacks
     (Self : Ref)
     return CosNotifyFilter.CallbackIDSeq
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.CallbackIDSeq;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CosNotifyFilter.Helper.Internals.Wrap
           (CosNotifyFilter.IDL_SEQUENCE_CosNotifyFilter_CallbackID.Sequence
              (Result_)'Unrestricted_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        get_callbacks_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "get_callbacks",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end get_callbacks;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (False
         or else (Is_A
           (Logical_Type_Id)
            or else CORBA.Object.Is_A
              (CORBA.Object.Ref
                 (Self),
               Logical_Type_Id)));
   end Is_A;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return ((CORBA.Is_Equivalent
        (Logical_Type_Id,
         CosNotifyFilter.Filter.Repository_Id)
         or else CORBA.Is_Equivalent
           (Logical_Type_Id,
            "IDL:omg.org/CORBA/Object:1.0"))
         or else False);
   end Is_A;

end CosNotifyFilter.Filter;
