with Interfaces; use Interfaces;

package body CORBA_Repository_Root_StringDef_Hash is

   P : constant array (0 .. 2) of Natural :=
     (2, 4, 6);

   T1 : constant array (0 .. 2) of Unsigned_8 :=
     (1, 3, 0);

   T2 : constant array (0 .. 2) of Unsigned_8 :=
     (18, 2, 10);

   G : constant array (0 .. 20) of Unsigned_8 :=
     (0, 3, 3, 0, 0, 0, 8, 4, 4, 0, 0, 0, 2, 0, 0, 0, 0, 9, 5, 0, 3);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 21;
         F2 := (F2 + Natural (T2 (K)) * J) mod 21;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 10;
   end Hash;

end CORBA_Repository_Root_StringDef_Hash;
