pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/event/CosEventComm.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with PolyORB.Any.NVList;
with PolyORB.Any;
with PolyORB.Requests;
with CORBA.ExceptionList;
with PolyORB.Types;
with CosEventComm.Helper;
with PolyORB.CORBA_P.Interceptors_Hooks;
with PolyORB.CORBA_P.Exceptions;

package body CosEventComm.PullSupplier is

   pull_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -------------------
   -- pull_Result_ --
   -------------------

   function pull_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (pull_Result_);
   begin
      return (Name => pull_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Any),
      Arg_Modes => 0);
   end pull_Result_;

   ----------
   -- pull --
   ----------

   function pull
     (Self : Ref)
     return CORBA.Any
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CORBA.Any;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (Result_'Unrestricted_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        pull_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosEventComm.Helper.TC_Disconnected);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "pull",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end pull;

   try_pull_Arg_Name_has_event_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("has_event");

   try_pull_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -----------------------
   -- try_pull_Result_ --
   -----------------------

   function try_pull_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (try_pull_Result_);
   begin
      return (Name => try_pull_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Any),
      Arg_Modes => 0);
   end try_pull_Result_;

   --------------
   -- try_pull --
   --------------

   procedure try_pull
     (Self : Ref;
      has_event : out CORBA.Boolean;
      Returns : out CORBA.Any)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CORBA.Any
        renames Returns;
      pragma Warnings (Off, Returns);
      pragma Suppress (Validity_Check, Returns);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (Result_'Unrestricted_Access);
      Arg_CC_has_event_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (has_event'Unrestricted_Access);
      Arg_Any_has_event_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CORBA.TC_Boolean,
            Arg_CC_has_event_'Unchecked_Access);
      pragma Warnings (Off, has_event);
      pragma Suppress (Validity_Check, has_event);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        try_pull_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         try_pull_Arg_Name_has_event_,
         PolyORB.Any.Any
           (Arg_Any_has_event_),
         PolyORB.Any.ARG_OUT);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosEventComm.Helper.TC_Disconnected);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "try_pull",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end try_pull;

   disconnect_pull_supplier_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ---------------------------------------
   -- disconnect_pull_supplier_Result_ --
   ---------------------------------------

   function disconnect_pull_supplier_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (disconnect_pull_supplier_Result_);
   begin
      return (Name => disconnect_pull_supplier_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end disconnect_pull_supplier_Result_;

   ------------------------------
   -- disconnect_pull_supplier --
   ------------------------------

   procedure disconnect_pull_supplier
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        disconnect_pull_supplier_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "disconnect_pull_supplier",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end disconnect_pull_supplier;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (False
         or else (Is_A
           (Logical_Type_Id)
            or else CORBA.Object.Is_A
              (CORBA.Object.Ref
                 (Self),
               Logical_Type_Id)));
   end Is_A;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return ((CORBA.Is_Equivalent
        (Logical_Type_Id,
         CosEventComm.PullSupplier.Repository_Id)
         or else CORBA.Is_Equivalent
           (Logical_Type_Id,
            "IDL:omg.org/CORBA/Object:1.0"))
         or else False);
   end Is_A;

end CosEventComm.PullSupplier;
