pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/notification/CosNotifyChannelAdmin.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with PolyORB.Any.NVList;
with PolyORB.Types;
with CORBA.Object.Helper;
with CORBA.Object;
with PolyORB.Any;
with CosEventComm.PushSupplier.Helper;
with PolyORB.Requests;
with CORBA.ExceptionList;
with CosEventChannelAdmin.Helper;
with PolyORB.CORBA_P.Interceptors_Hooks;
with PolyORB.CORBA_P.Exceptions;
with CosNotification.Helper;
with CosNotifyComm.Helper;
with CosEventComm.Helper;
with CosNotification.QoSAdmin;
with CosNotifyFilter.FilterAdmin;
with CosNotifyComm.PushConsumer;
with CosNotifyComm.NotifyPublish;
with CosEventComm.PushConsumer;

package body CosNotifyChannelAdmin.ProxyPushConsumer is

   connect_any_push_supplier_Arg_Name_push_supplier_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("push_supplier");

   connect_any_push_supplier_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ----------------------------------------
   -- connect_any_push_supplier_Result_ --
   ----------------------------------------

   function connect_any_push_supplier_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (connect_any_push_supplier_Result_);
   begin
      return (Name => connect_any_push_supplier_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end connect_any_push_supplier_Result_;

   -------------------------------
   -- connect_any_push_supplier --
   -------------------------------

   procedure connect_any_push_supplier
     (Self : Ref;
      push_supplier : CosEventComm.PushSupplier.Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_push_supplier_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (push_supplier)'Unrestricted_Access);
      Arg_Any_push_supplier_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosEventComm.PushSupplier.Helper.TC_PushSupplier,
            Arg_CC_push_supplier_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        connect_any_push_supplier_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         connect_any_push_supplier_Arg_Name_push_supplier_,
         PolyORB.Any.Any
           (Arg_Any_push_supplier_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosEventChannelAdmin.Helper.TC_AlreadyConnected);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "connect_any_push_supplier",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end connect_any_push_supplier;

   offer_change_Arg_Name_added_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("added");

   offer_change_Arg_Name_removed_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("removed");

   offer_change_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ---------------------------
   -- offer_change_Result_ --
   ---------------------------

   function offer_change_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (offer_change_Result_);
   begin
      return (Name => offer_change_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end offer_change_Result_;

   ------------------
   -- offer_change --
   ------------------

   procedure offer_change
     (Self : Ref;
      added : CosNotification.EventTypeSeq;
      removed : CosNotification.EventTypeSeq)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_added_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_EventType.Sequence
              (added)'Unrestricted_Access);
      Arg_Any_added_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_EventTypeSeq,
            Arg_CC_added_'Unchecked_Access);
      Arg_CC_removed_ : aliased PolyORB.Any.Content'Class :=
        CosNotification.Helper.Internals.Wrap
           (CosNotification.IDL_SEQUENCE_CosNotification_EventType.Sequence
              (removed)'Unrestricted_Access);
      Arg_Any_removed_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CosNotification.Helper.TC_EventTypeSeq,
            Arg_CC_removed_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        offer_change_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         offer_change_Arg_Name_added_,
         PolyORB.Any.Any
           (Arg_Any_added_),
         PolyORB.Any.ARG_IN);
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         offer_change_Arg_Name_removed_,
         PolyORB.Any.Any
           (Arg_Any_removed_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyComm.Helper.TC_InvalidEventType);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "offer_change",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end offer_change;

   push_Arg_Name_data_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("data");

   push_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   -------------------
   -- push_Result_ --
   -------------------

   function push_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (push_Result_);
   begin
      return (Name => push_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end push_Result_;

   ----------
   -- push --
   ----------

   procedure push
     (Self : Ref;
      data : CORBA.Any)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Arg_CC_data_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (data'Unrestricted_Access);
      Arg_Any_data_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CORBA.TC_Any,
            Arg_CC_data_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        push_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         push_Arg_Name_data_,
         PolyORB.Any.Any
           (Arg_Any_data_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosEventComm.Helper.TC_Disconnected);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "push",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end push;

   disconnect_push_consumer_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ---------------------------------------
   -- disconnect_push_consumer_Result_ --
   ---------------------------------------

   function disconnect_push_consumer_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (disconnect_push_consumer_Result_);
   begin
      return (Name => disconnect_push_consumer_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CORBA.TC_Void),
      Arg_Modes => 0);
   end disconnect_push_consumer_Result_;

   ------------------------------
   -- disconnect_push_consumer --
   ------------------------------

   procedure disconnect_push_consumer
     (Self : Ref)
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Request_ : aliased PolyORB.Requests.Request;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        disconnect_push_consumer_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "disconnect_push_consumer",
         Arg_List => Argument_List_,
         Result => Result_Nv_);
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
   end disconnect_push_consumer;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (False
         or else (Is_A
           (Logical_Type_Id)
            or else CORBA.Object.Is_A
              (CORBA.Object.Ref
                 (Self),
               Logical_Type_Id)));
   end Is_A;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (((CORBA.Is_Equivalent
        (Logical_Type_Id,
         CosNotifyChannelAdmin.ProxyPushConsumer.Repository_Id)
         or else CORBA.Is_Equivalent
           (Logical_Type_Id,
            "IDL:omg.org/CORBA/Object:1.0"))
         or else (((CORBA.Is_Equivalent
           (Logical_Type_Id,
            CosNotifyChannelAdmin.ProxyConsumer.Repository_Id)
            or else (CORBA.Is_Equivalent
              (Logical_Type_Id,
               CosNotification.QoSAdmin.Repository_Id)
               or else CORBA.Is_Equivalent
                 (Logical_Type_Id,
                  CosNotifyFilter.FilterAdmin.Repository_Id)))
            or else CORBA.Is_Equivalent
              (Logical_Type_Id,
               CosNotifyComm.PushConsumer.Repository_Id))
            or else (CORBA.Is_Equivalent
              (Logical_Type_Id,
               CosNotifyComm.NotifyPublish.Repository_Id)
               or else CORBA.Is_Equivalent
                 (Logical_Type_Id,
                  CosEventComm.PushConsumer.Repository_Id))))
         or else False);
   end Is_A;

end CosNotifyChannelAdmin.ProxyPushConsumer;
