pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/notification/CosNotifyFilter.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with PolyORB.Any.NVList;
with CORBA.Object.Helper;
with PolyORB.Any;
with PolyORB.Types;
with PolyORB.Requests;
with CORBA.ExceptionList;
with CosNotifyFilter.Helper;
with CosNotifyFilter.Filter.Helper;
with PolyORB.CORBA_P.Interceptors_Hooks;
with PolyORB.CORBA_P.Exceptions;
with CosNotifyFilter.MappingFilter.Helper;

package body CosNotifyFilter.FilterFactory is

   create_filter_Arg_Name_constraint_grammar_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("constraint_grammar");

   create_filter_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ----------------------------
   -- create_filter_Result_ --
   ----------------------------

   function create_filter_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (create_filter_Result_);
   begin
      return (Name => create_filter_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.Filter.Helper.TC_Filter),
      Arg_Modes => 0);
   end create_filter_Result_;

   -------------------
   -- create_filter --
   -------------------

   function create_filter
     (Self : Ref;
      constraint_grammar : CORBA.String)
     return CosNotifyFilter.Filter.Ref
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.Filter.Ref;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (Result_)'Unrestricted_Access);
      Arg_CC_constraint_grammar_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (constraint_grammar'Unrestricted_Access);
      Arg_Any_constraint_grammar_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CORBA.TC_String,
            Arg_CC_constraint_grammar_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        create_filter_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         create_filter_Arg_Name_constraint_grammar_,
         PolyORB.Any.Any
           (Arg_Any_constraint_grammar_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_InvalidGrammar);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "create_filter",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end create_filter;

   create_mapping_filter_Arg_Name_constraint_grammar_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("constraint_grammar");

   create_mapping_filter_Arg_Name_default_value_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("default_value");

   create_mapping_filter_Result_Name_ : constant PolyORB.Types.Identifier :=
     PolyORB.Types.To_PolyORB_String
        ("Result");

   ------------------------------------
   -- create_mapping_filter_Result_ --
   ------------------------------------

   function create_mapping_filter_Result_ return PolyORB.Any.NamedValue is
      pragma Inline (create_mapping_filter_Result_);
   begin
      return (Name => create_mapping_filter_Result_Name_,
      Argument => CORBA.Internals.Get_Empty_Any
        (CosNotifyFilter.MappingFilter.Helper.TC_MappingFilter),
      Arg_Modes => 0);
   end create_mapping_filter_Result_;

   ---------------------------
   -- create_mapping_filter --
   ---------------------------

   function create_mapping_filter
     (Self : Ref;
      constraint_grammar : CORBA.String;
      default_value : CORBA.Any)
     return CosNotifyFilter.MappingFilter.Ref
   is
      Argument_List_ : PolyORB.Any.NVList.Ref;
      Result_ : CosNotifyFilter.MappingFilter.Ref;
      pragma Warnings (Off, Result_);
      pragma Suppress (Validity_Check, Result_);
      Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
        CORBA.Object.Helper.Wrap
           (CORBA.Object.Ref
              (Result_)'Unrestricted_Access);
      Arg_CC_constraint_grammar_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (constraint_grammar'Unrestricted_Access);
      Arg_Any_constraint_grammar_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CORBA.TC_String,
            Arg_CC_constraint_grammar_'Unchecked_Access);
      Arg_CC_default_value_ : aliased PolyORB.Any.Content'Class :=
        CORBA.Wrap
           (default_value'Unrestricted_Access);
      Arg_Any_default_value_ : constant CORBA.Any :=
        CORBA.Internals.Get_Wrapper_Any
           (CORBA.TC_Any,
            Arg_CC_default_value_'Unchecked_Access);
      Request_ : aliased PolyORB.Requests.Request;
      Exception_List_ : CORBA.ExceptionList.Ref;
      Result_Nv_ : PolyORB.Any.NamedValue :=
        create_mapping_filter_Result_;
   begin
      if CORBA.Object.Is_Nil
        (CORBA.Object.Ref
           (Self))
      then
         CORBA.Raise_Inv_Objref
           (CORBA.Default_Sys_Member);
      end if;
      --  Create the Argument list
      PolyORB.Any.NVList.Create
        (Argument_List_);
      --  Fill the Argument list
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         create_mapping_filter_Arg_Name_constraint_grammar_,
         PolyORB.Any.Any
           (Arg_Any_constraint_grammar_),
         PolyORB.Any.ARG_IN);
      PolyORB.Any.NVList.Add_Item
        (Argument_List_,
         create_mapping_filter_Arg_Name_default_value_,
         PolyORB.Any.Any
           (Arg_Any_default_value_),
         PolyORB.Any.ARG_IN);
      --  Create the Exception list
      CORBA.ExceptionList.Create_List
        (Exception_List_);
      CORBA.ExceptionList.Add
        (Exception_List_,
         CosNotifyFilter.Helper.TC_InvalidGrammar);
      --  Setting the result value
      PolyORB.Any.Set_Value
        (PolyORB.Any.Get_Container
           (Result_Nv_.Argument).all,
         Arg_CC_Result__'Unrestricted_Access);
      --  Creating the request
      PolyORB.Requests.Setup_Request
        (Req => Request_,
         Target => CORBA.Object.Internals.To_PolyORB_Ref
           (CORBA.Object.Ref
              (Self)),
         Operation => "create_mapping_filter",
         Arg_List => Argument_List_,
         Result => Result_Nv_,
         Exc_List => CORBA.ExceptionList.Internals.To_PolyORB_Ref
           (Exception_List_));
      --  Invoking the request (synchronously or asynchronously)
      PolyORB.CORBA_P.Interceptors_Hooks.Client_Invoke
        (Request_'Access,
         PolyORB.Requests.Flags
           (0));
      --  Raise exception, if needed
      PolyORB.CORBA_P.Exceptions.Request_Raise_Occurrence
        (Request_);
      --  Return value
      return Result_;
   end create_mapping_filter;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Self : Ref;
      Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return (False
         or else (Is_A
           (Logical_Type_Id)
            or else CORBA.Object.Is_A
              (CORBA.Object.Ref
                 (Self),
               Logical_Type_Id)));
   end Is_A;

   ----------
   -- Is_A --
   ----------

   function Is_A
     (Logical_Type_Id : PolyORB.Std.String)
     return CORBA.Boolean
   is
   begin
      return ((CORBA.Is_Equivalent
        (Logical_Type_Id,
         CosNotifyFilter.FilterFactory.Repository_Id)
         or else CORBA.Is_Equivalent
           (Logical_Type_Id,
            "IDL:omg.org/CORBA/Object:1.0"))
         or else False);
   end Is_A;

end CosNotifyFilter.FilterFactory;
