with Interfaces; use Interfaces;

package body CosNotifyFilter_MappingFilter_Hash is

   P : constant array (0 .. 3) of Natural :=
     (1, 4, 5, 7);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (7, 13, 30, 26);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (6, 25, 18, 2);

   G : constant array (0 .. 34) of Unsigned_8 :=
     (0, 15, 0, 0, 0, 0, 0, 0, 0, 5, 0, 14, 0, 0, 0, 14, 10, 0, 5, 0, 1, 0,
      0, 0, 8, 3, 1, 2, 3, 0, 16, 6, 16, 6, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 35;
         F2 := (F2 + Natural (T2 (K)) * J) mod 35;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 17;
   end Hash;

end CosNotifyFilter_MappingFilter_Hash;
