pragma Style_Checks ("NM32766");

---------------------------------------------------
--  This file has been generated automatically from
--  /build/polyorb-VFKoNN/polyorb-2.11~20140418/idls/cos/event/CosTypedEventChannelAdmin.idl
--  by IAC (IDL to Ada Compiler) 2.11.0w (Debian release 20140418-3.2).
---------------------------------------------------
--  NOTE: If you modify this file by hand, your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
---------------------------------------------------

with CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl;
with CosEventComm.PushSupplier;
with CORBA;
pragma Elaborate_All (CORBA);
with CORBA.Object.Helper;
with CORBA.Object;
with PolyORB.Any;
with CosEventComm.PushSupplier.Helper;
with CORBA.NVList;
with CORBA.ServerRequest;
with CosEventChannelAdmin;
with CosEventChannelAdmin.Helper;
with CosEventComm;
with CosEventComm.Helper;
with PolyORB.CORBA_P.IR_Hooks;
with PolyORB.CORBA_P.Domain_Management;
with CosTypedEventChannelAdmin_TypedProxyPushConsumer_Hash;
with PolyORB.Std;
with PortableServer;
with CORBA.ORB;
with PolyORB.CORBA_P.Exceptions;
with PolyORB.Qos.Exception_Informations;
with PolyORB.Utils.Strings;
with PolyORB.Utils.Strings.Lists;
with PolyORB.Initialization;

package body CosTypedEventChannelAdmin.TypedProxyPushConsumer.Skel is

   connect_push_supplier_Arg_Name_push_supplier_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("push_supplier");

   push_Arg_Name_data_ : constant CORBA.Identifier :=
     CORBA.To_CORBA_String
        ("data");

   N_Operations : constant PolyORB.Std.Natural :=
     9;

   type String_Ptr is
     access PolyORB.Std.String;

   Invoke_Db : array (0 .. (N_Operations
      - 1)) of String_Ptr :=
     (others => null);

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String);

   ------------------------
   -- Register_Procedure --
   ------------------------

   procedure Register_Procedure
     (Operation_Name : PolyORB.Std.String)
   is
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;
   begin
      Index_ :=
        CosTypedEventChannelAdmin_TypedProxyPushConsumer_Hash.Hash
           (Operation_Name);
      if (Invoke_Db
        (Index_)
         /= null)
      then
         raise Program_Error;
      end if;
      Invoke_Name_Access :=
        new PolyORB.Std.String'
           (Operation_Name);
      Invoke_Db
        (Index_) :=
        Invoke_Name_Access;
   end Register_Procedure;

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr);

   ------------
   -- Invoke --
   ------------

   procedure Invoke
     (Self : PortableServer.Servant;
      Request : CORBA.ServerRequest.Object_Ptr)
   is
      Operation_ : constant PolyORB.Std.String :=
        CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation
              (Request.all));
      Argument_List_ : CORBA.NVList.Ref;
      Index_ : PolyORB.Std.Natural;
      Invoke_Name_Access : String_Ptr;

      procedure Invoke_connect_push_supplier;

      ----------------------------------
      -- Invoke_connect_push_supplier --
      ----------------------------------

      procedure Invoke_connect_push_supplier is
         Argument_push_supplier_ : CosEventComm.PushSupplier.Ref;
         pragma Warnings (Off, Argument_push_supplier_);
         pragma Suppress (Validity_Check, Argument_push_supplier_);
         Arg_CC_push_supplier_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (CORBA.Object.Ref
                 (Argument_push_supplier_)'Unrestricted_Access);
         Arg_Any_push_supplier_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CosEventComm.PushSupplier.Helper.TC_PushSupplier,
               Arg_CC_push_supplier_'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            connect_push_supplier_Arg_Name_push_supplier_,
            Arg_Any_push_supplier_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         begin
            --  Call Implementation
            CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.connect_push_supplier
              (CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.Object'Class
                 (Self.all)'Access,
               Argument_push_supplier_);
         exception
            when E : CosEventChannelAdmin.AlreadyConnected =>
               declare
                  Members : CosEventChannelAdmin.AlreadyConnected_Members;
               begin
                  CosEventChannelAdmin.Get_Members
                    (E,
                     Members);
                  CORBA.ServerRequest.Set_Exception
                    (Request,
                     CosEventChannelAdmin.Helper.To_Any
                       (Members));
                  return;
               end;
         end;
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_connect_push_supplier;

      procedure Invoke_push;

      -----------------
      -- Invoke_push --
      -----------------

      procedure Invoke_push is
         Argument_data_ : CORBA.Any;
         pragma Warnings (Off, Argument_data_);
         pragma Suppress (Validity_Check, Argument_data_);
         Arg_CC_data_ : aliased PolyORB.Any.Content'Class :=
           CORBA.Wrap
              (Argument_data_'Unrestricted_Access);
         Arg_Any_data_ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.TC_Any,
               Arg_CC_data_'Unchecked_Access);
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            push_Arg_Name_data_,
            Arg_Any_data_,
            CORBA.ARG_IN);
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         begin
            --  Call Implementation
            CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.push
              (CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.Object'Class
                 (Self.all)'Access,
               Argument_data_);
         exception
            when E : CosEventComm.Disconnected =>
               declare
                  Members : CosEventComm.Disconnected_Members;
               begin
                  CosEventComm.Get_Members
                    (E,
                     Members);
                  CORBA.ServerRequest.Set_Exception
                    (Request,
                     CosEventComm.Helper.To_Any
                       (Members));
                  return;
               end;
         end;
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_push;

      procedure Invoke_disconnect_push_consumer;

      -------------------------------------
      -- Invoke_disconnect_push_consumer --
      -------------------------------------

      procedure Invoke_disconnect_push_consumer is
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.disconnect_push_consumer
           (CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.Object'Class
              (Self.all)'Access);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_disconnect_push_consumer;

      procedure Invoke_get_typed_consumer;

      -------------------------------
      -- Invoke_get_typed_consumer --
      -------------------------------

      procedure Invoke_get_typed_consumer is
         Result_ : CORBA.Object.Ref;
         pragma Warnings (Off, Result_);
         pragma Suppress (Validity_Check, Result_);
         Arg_CC_Result__ : aliased PolyORB.Any.Content'Class :=
           CORBA.Object.Helper.Wrap
              (Result_'Unrestricted_Access);
         Arg_Any_Result__ : constant CORBA.Any :=
           CORBA.Internals.Get_Wrapper_Any
              (CORBA.Object.Helper.TC_Object,
               Arg_CC_Result__'Unchecked_Access);
      begin
         --  Processing request
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         --  Call Implementation
         Result_ :=
           CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.get_typed_consumer
              (CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.Object'Class
                 (Self.all)'Access);
         --  Setting the result
         CORBA.ServerRequest.Set_Result
           (Request,
            Arg_Any_Result__);
         CORBA.NVList.Internals.Clone_Out_Args
           (Argument_List_);
      end Invoke_get_typed_consumer;

      procedure Invoke_Uis_a;

      ------------------
      -- Invoke_Uis_a --
      ------------------

      procedure Invoke_Uis_a is
         Type_Id_ : CORBA.String;
         Arg_Name_Type_Id_ : constant CORBA.Identifier :=
           CORBA.To_CORBA_String
              ("Type_Id_");
         Argument_Type_Id_ : constant CORBA.Any :=
           CORBA.To_Any
              (Type_Id_);
         Result_ : CORBA.Boolean;
      begin
         CORBA.NVList.Add_Item
           (Argument_List_,
            Arg_Name_Type_Id_,
            Argument_Type_Id_,
            CORBA.ARG_IN);
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         Type_Id_ :=
           CORBA.From_Any
              (Argument_Type_Id_);
         Result_ :=
           Is_A
              (CORBA.To_Standard_String
                 (Type_Id_));
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (Result_));
      end Invoke_Uis_a;

      procedure Invoke_Uinterface;

      -----------------------
      -- Invoke_Uinterface --
      -----------------------

      procedure Invoke_Uinterface is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
              (CORBA.Object.Ref
                 (PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
                    (CORBA.To_CORBA_String
                       (Repository_Id)))));
      end Invoke_Uinterface;

      procedure Invoke_Udomain_managers;

      -----------------------------
      -- Invoke_Udomain_managers --
      -----------------------------

      procedure Invoke_Udomain_managers is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers
              (Self));
      end Invoke_Udomain_managers;

      procedure Invoke_Unon_existent;

      --------------------------
      -- Invoke_Unon_existent --
      --------------------------

      procedure Invoke_Unon_existent is
      begin
         CORBA.ServerRequest.Arguments
           (Request,
            Argument_List_);
         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.To_Any
              (CORBA.Boolean'
                 (False)));
      end Invoke_Unon_existent;

      procedure Dispatch;

      --------------
      -- Dispatch --
      --------------

      procedure Dispatch is
      begin
         case Index_ is
            when 0 =>
               Invoke_connect_push_supplier;
            when 1 =>
               Invoke_push;
            when 2 =>
               Invoke_disconnect_push_consumer;
            when 3 =>
               Invoke_get_typed_consumer;
            when 5 =>
               Invoke_Uinterface;
            when 6 =>
               Invoke_Udomain_managers;
            when 7
               | 8 =>
               Invoke_Unon_existent;
            when 4 =>
               Invoke_Uis_a;
            pragma Warnings (Off);
            when others =>
               raise Program_Error;
            pragma Warnings (On);

         end case;
      end Dispatch;

   begin
      CORBA.ORB.Create_List
        (0,
         Argument_List_);
      Index_ :=
        CosTypedEventChannelAdmin_TypedProxyPushConsumer_Hash.Hash
           (Operation_);
      Invoke_Name_Access :=
        Invoke_Db
           (Index_);
      begin
         if (Operation_
            = Invoke_Name_Access.all)
         then
            Dispatch;
         else
            CORBA.Raise_Bad_Operation
              (CORBA.Default_Sys_Member);
         end if;
      exception
         when E : others =>
            CORBA.ServerRequest.Set_Exception
              (Request,
               PolyORB.CORBA_P.Exceptions.System_Exception_To_Any
                 (E));
            PolyORB.Qos.Exception_Informations.Set_Exception_Information
              (Request.all,
               E);
      end;
   end Invoke;

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean;

   ------------------
   -- Servant_Is_A --
   ------------------

   function Servant_Is_A
     (Obj : PortableServer.Servant)
     return Boolean
   is
   begin
      return (Obj.all
         in CosTypedEventChannelAdmin.TypedProxyPushConsumer.Impl.Object'Class);
   end Servant_Is_A;

   -----------------------------
   -- Deferred_Initialization --
   -----------------------------

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CosTypedEventChannelAdmin.TypedProxyPushConsumer.Repository_Id,
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);
      Register_Procedure
        ("connect_push_supplier");
      Register_Procedure
        ("push");
      Register_Procedure
        ("disconnect_push_consumer");
      Register_Procedure
        ("get_typed_consumer");
      Register_Procedure
        ("_is_a");
      Register_Procedure
        ("_interface");
      Register_Procedure
        ("_domain_managers");
      Register_Procedure
        ("_non_existent");
      Register_Procedure
        ("_not_existent");
   end Deferred_Initialization;

begin
   declare
      use PolyORB.Utils.Strings;
      use PolyORB.Utils.Strings.Lists;
   begin
      PolyORB.Initialization.Register_Module
        (PolyORB.Initialization.Module_Info'
           (Name => +"CosTypedEventChannelAdmin.TypedProxyPushConsumer.Skel",
            Conflicts => PolyORB.Utils.Strings.Lists.Empty,
            Depends => PolyORB.Utils.Strings.Lists.Empty
               & "CosEventChannelAdmin.ProxyPushConsumer.Skel?"
               & "CosTypedEventComm.TypedPushConsumer.Skel?",
            Provides => PolyORB.Utils.Strings.Lists.Empty,
            Implicit => False,
            Init => Deferred_Initialization'Access,
            Shutdown => null));
   end;
end CosTypedEventChannelAdmin.TypedProxyPushConsumer.Skel;
